exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _ast = require('../ast');

var _parsingTools = require('../parsing-tools');

var _instrumented = require('../instrumented');

// Transform:
// obj[prop] = value -->
// __set$(object, prop, value)

exports.default = {
    nodeReplacementRequireTransform: true,

    nodeTypes: [_parsingTools.Syntax.AssignmentExpression],

    condition: function (node) {
        var left = node.left;

        if (node.operator === '=' && left.type === _parsingTools.Syntax.MemberExpression && left.computed) return left.property.type === _parsingTools.Syntax.Literal ? _instrumented.shouldInstrumentProperty(left.property.value) : true;

        return false;
    },

    run: function (node, parent, key) {
        var newNode = _ast.createComputedPropertySetWrapper(node.left.property, node.left.object, node.right);

        _ast.replaceNode(node, newNode, parent, key);
    }
};
module.exports = exports.default;