exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _ast = require('../ast');

var _parsingTools = require('../parsing-tools');

// Transform:
// val1 += val2
// --> val1 = val1 + val2

exports.default = {
    nodeReplacementRequireTransform: true,

    nodeTypes: [_parsingTools.Syntax.AssignmentExpression],

    condition: function (node) {
        return node.operator === '+=';
    },

    run: function (node, parent, key) {
        var newNode = _ast.createExpandedConcatOperation(node.left, node.right);

        _ast.replaceNode(node, newNode, parent, key);
    }
};
module.exports = exports.default;