exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _parsingTools = require('../parsing-tools');

var _ast = require('../ast');

// Transform:
// for(obj[prop] in src), for(obj.prop in src) -->
// for(var __set$temp in src) { obj[prop] = __set$temp; }

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_parsingTools.Syntax.ForInStatement],

    condition: function (node) {
        return node.left.type === _parsingTools.Syntax.MemberExpression;
    },

    run: function (node) {
        var tempVarAst = _ast.createTempVarIdentifier();

        node.body.body.unshift(_ast.createAssignmentExprStmt(node.left, tempVarAst));

        node.left = _ast.createVarDeclaration(tempVarAst);
    }
};
module.exports = exports.default;