exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _ast = require('../ast');

var _parsingTools = require('../parsing-tools');

// Transform:
// new Function(params..., body); -->
// new Function(params..., __proc$Script(body));

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_parsingTools.Syntax.NewExpression],

    condition: function (node) {
        return node.callee.name === 'Function' && node.arguments.length;
    },

    run: function (node) {
        var lastArgIndex = node.arguments.length - 1;

        node.arguments[lastArgIndex] = _ast.createProcessScriptMethCall(node.arguments[lastArgIndex]);
    }
};
module.exports = exports.default;