var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _ast = require('../ast');

var _instruction = require('../instruction');

var _instruction2 = _interopRequireDefault(_instruction);

var _parsingTools = require('../parsing-tools');

// Transform:
// location -->
// __get$Loc(location)

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_parsingTools.Syntax.Identifier],

    condition: function (node, parent) {
        if (node.name !== 'location') return false;

        // Skip: var location = value;
        if (parent.type === _parsingTools.Syntax.VariableDeclarator && parent.id === node) return false;

        // Skip: location = value
        if (parent.type === _parsingTools.Syntax.AssignmentExpression && parent.left === node) return false;

        // Skip: object.location || location.field
        if (parent.type === _parsingTools.Syntax.MemberExpression) return false;

        // Skip: { location: value }
        if (parent.type === _parsingTools.Syntax.Property && parent.key === node) return false;

        // Skip: location++ || location-- || ++location || --location
        if (parent.type === _parsingTools.Syntax.UpdateExpression && parent.operator === '++' || parent.operator === '--') return false;

        // Skip: function (location) { ... } || function func(location) { ... }
        if ((parent.type === _parsingTools.Syntax.FunctionExpression || parent.type === _parsingTools.Syntax.FunctionDeclaration) && parent.params.indexOf(node) !== -1) return false;

        // Skip already transformed: __get$Loc(location)
        if (parent.type === _parsingTools.Syntax.CallExpression && parent.callee.name === _instruction2.default.getLocation) return false;

        return true;
    },

    run: function (node, parent, key) {
        var newNode = _ast.createLocationGetWrapper();

        _ast.replaceNode(node, newNode, parent, key);
    }
};
module.exports = exports.default;