exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _ast = require('../ast');

var _parsingTools = require('../parsing-tools');

// Transform:
// location.field; location[field] -->
// __get$Loc(location).field; __get$Loc(location)[field];

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_parsingTools.Syntax.MemberExpression],

    condition: function (node, parent) {
        // Skip: for(location.field in obj)
        if (parent.type === _parsingTools.Syntax.ForInStatement && parent.left === node) return false;

        return node.object.name === 'location';
    },

    run: function (node) {
        node.object = _ast.createLocationGetWrapper();
    }
};
module.exports = exports.default;