exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _ast = require('../ast');

var _parsingTools = require('../parsing-tools');

// Transform:
// location = value -->
// (function(){ return __set$Loc(location, value) || location = value;}.apply(this))

exports.default = {
    nodeReplacementRequireTransform: false,

    nodeTypes: [_parsingTools.Syntax.AssignmentExpression],

    condition: function (node) {
        return node.operator === '=' && node.left.type === _parsingTools.Syntax.Identifier && node.left.name === 'location';
    },

    run: function (node, parent, key) {
        var newNode = _ast.createLocationSetWrapper(node.right);

        _ast.replaceNode(node, newNode, parent, key);
    }
};
module.exports = exports.default;