exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _ast = require('../ast');

var _parsingTools = require('../parsing-tools');

var _instrumented = require('../instrumented');

// Transform:
// obj.method(args...); obj[method](args...); -->
// _call$(obj, 'method', args...); _call$(obj, method, args...);

exports.default = {
    nodeReplacementRequireTransform: true,

    nodeTypes: [_parsingTools.Syntax.CallExpression],

    condition: function (node) {
        var callee = node.callee;

        if (callee.type === _parsingTools.Syntax.MemberExpression) {
            if (callee.computed) {
                return callee.property.type === _parsingTools.Syntax.Literal ? _instrumented.shouldInstrumentMethod(callee.property.value) : true;
            }

            return _instrumented.shouldInstrumentMethod(callee.property.name);
        }

        return false;
    },

    run: function (node, parent, key) {
        var callee = node.callee;
        var meth = callee.computed ? callee.property : _ast.createStringLiteral(callee.property.name);
        var newNode = _ast.createMethCallWrapper(callee.object, meth, node.arguments);

        _ast.replaceNode(node, newNode, parent, key);
    }
};
module.exports = exports.default;