exports.__esModule = true;
// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _ast = require('../ast');

var _parsingTools = require('../parsing-tools');

var _instrumented = require('../instrumented');

// Transform:
// obj.<wrappable-property> = value -->
// __set$(obj, '<wrappable-property>', value)

exports.default = {
    nodeReplacementRequireTransform: true,

    nodeTypes: [_parsingTools.Syntax.AssignmentExpression],

    condition: function (node) {
        return node.operator === '=' && node.left.type === _parsingTools.Syntax.MemberExpression && !node.left.computed && node.left.property.type === _parsingTools.Syntax.Identifier && _instrumented.shouldInstrumentProperty(node.left.property.name);
    },

    run: function (node, parent, key) {
        var newNode = _ast.createPropertySetWrapper(node.left.property.name, node.left.object, node.right);

        _ast.replaceNode(node, newNode, parent, key);
    }
};
module.exports = exports.default;