var _taggedTemplateLiteralLoose = require('babel-runtime/helpers/tagged-template-literal-loose').default;

var _classCallCheck = require('babel-runtime/helpers/class-call-check').default;

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default').default;

exports.__esModule = true;

var _templateObject = _taggedTemplateLiteralLoose(['\n            ', '\n            var __w$= typeof window!=="undefined"&&window;\n            __w$ && __w$["', '"] && __w$["', '"]();\n            var ', '=__w$?__w$.', ':function(l){return l},\n                ', '=__w$?__w$.', ':function(l,v){return l = v},\n                ', '=__w$?__w$.', ':function(o,p,v){return o[p] = v},\n                ', '=__w$?__w$.', ':function(o,p){return o[p]},\n                ', '=__w$?__w$.', ':function(o,p,a){return o[p].apply(o,a)},\n                ', '=__w$?__w$.', ':function(s){return s};\n            ', '\n        '], ['\n            ', '\n            var __w$= typeof window!=="undefined"&&window;\n            __w$ && __w$["', '"] && __w$["', '"]();\n            var ', '=__w$?__w$.', ':function(l){return l},\n                ', '=__w$?__w$.', ':function(l,v){return l = v},\n                ', '=__w$?__w$.', ':function(o,p,v){return o[p] = v},\n                ', '=__w$?__w$.', ':function(o,p){return o[p]},\n                ', '=__w$?__w$.', ':function(o,p,a){return o[p].apply(o,a)},\n                ', '=__w$?__w$.', ':function(s){return s};\n            ', '\n        ']);

// -------------------------------------------------------------
// WARNING: this file is used by both the client and the server.
// Do not use any browser or node-specific API!
// -------------------------------------------------------------

var _processingDomInternalProperties = require('../processing/dom/internal-properties');

var _processingDomInternalProperties2 = _interopRequireDefault(_processingDomInternalProperties);

var _dedent = require('dedent');

var _dedent2 = _interopRequireDefault(_dedent);

var _js = require('./js');

var _js2 = _interopRequireDefault(_js);

var _jsInstruction = require('./js/instruction');

var _jsInstruction2 = _interopRequireDefault(_jsInstruction);

// Byte Order Mark
var BOM_REGEX = new RegExp('^(\\xEF\\xBB\\xBF|' + '\\xFE\\xFF|' + '\\xFF\\xFE|' + '\\x00\\x00\\xFE\\xFF|' + '\\xFF\\xFE\\x00\\x00|' + '\\x2B\\x2F\\x76\\x38|' + '\\x2B\\x2F\\x76\\x39|' + '\\x2B\\x2F\\x76\\x2B|' + '\\x2B\\x2F\\x76\\x2F|' + '\\xF7\\x64\\x4C|' + '\\xDD\\x73\\x66\\x73|' + '\\x0E\\xFE\\xFF|' + '\\xFB\\xEE\\x28|' + '\\x84\\x31\\x95\\x33)');

var ScriptProcessor = (function () {
    function ScriptProcessor() {
        _classCallCheck(this, ScriptProcessor);

        var HEADER_PREFIX = '/*hammerhead|script-processing-header|start*/';
        var HEADER_POSTFIX = '/*hammerhead|script-processing-header|end*/';

        this.SCRIPT_HEADER = _dedent2.default(_templateObject, HEADER_PREFIX, _processingDomInternalProperties2.default.overrideDomMethodName, _processingDomInternalProperties2.default.overrideDomMethodName, _jsInstruction2.default.getLocation, _jsInstruction2.default.getLocation, _jsInstruction2.default.setLocation, _jsInstruction2.default.setLocation, _jsInstruction2.default.setProperty, _jsInstruction2.default.setProperty, _jsInstruction2.default.getProperty, _jsInstruction2.default.getProperty, _jsInstruction2.default.callMethod, _jsInstruction2.default.callMethod, _jsInstruction2.default.processScript, _jsInstruction2.default.processScript, HEADER_POSTFIX);

        this.SCRIPT_HEADER_REG_EX = new RegExp((HEADER_PREFIX + '[\\S\\s]+?' + HEADER_POSTFIX).replace(/\/|\*|\|/g, '\\$&'), 'i');
    }

    ScriptProcessor.prototype.process = function process(text, withoutHeader) {
        var bom = this.getBOM(text);

        if (bom) text = text.replace(bom, '');

        text = _js2.default.process(text);

        // NOTE: Overriding methods that work with the DOM.
        if (!_js2.default.isDataScript(text) && !withoutHeader && text.indexOf(_processingDomInternalProperties2.default.overrideDomMethodName) === -1) text = this.SCRIPT_HEADER + text;

        return bom ? bom + text : text;
    };

    ScriptProcessor.prototype.cleanUpHeader = function cleanUpHeader(text) {
        return text.replace(this.SCRIPT_HEADER_REG_EX, '');
    };

    ScriptProcessor.prototype.getBOM = function getBOM(text) {
        var match = text.match(BOM_REGEX);

        return match ? match[0] : null;
    };

    return ScriptProcessor;
})();

exports.default = new ScriptProcessor();
module.exports = exports.default;